# Serverless Clusters

WarpStream Serverless clusters are entirely managed by WarpStream. In addition to the fully-managed control plane, which is used by all cluster types, the Agents for Serverless clusters run in WarpStream's environment, and use object storage in WarpStream's cloud account.

While Serverless cluster operations are similar to BYOC clusters, there are some known differences you should be aware of.

### Dedicated Kafka Headers

If you are using a Serverless cluster, then the Kafka headers starting with “\_*ws*” are reserved for WarpStream. Concretely this means that:

* Produce requests containing records with at least one header starting with this prefix will be rejected.
* Those headers are used for internal purposes only and will never be returned to users when records are fetched.

### Ratelimits

Severless clusters are rate-limited as follows:

#### Global ratelimits (per virtual cluster)

* Produce Compressed bytes: 20Mib/s
* Produce Uncompressed bytes: 20Mib/s
* Fetch Uncompressed bytes: 80Mib/s
* New Connections Rate: 1k/s
* Produce Requests Rate: 6k/s
* General Requests Rate: 1k/s
* Fetch Parallel Requests: 360
* Consumer Rebalance Timeout: 2m

#### Connection Ratelimits (per connection)

* Connection throughput: 64 MiB/s.
* Number of Connections: 2k

#### Request Ratelimits

* Max TCP Request Size: 32MiB
* Max Produce Request Uncompressed Bytes: 20 MiB


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.warpstream.com/warpstream/kafka/reference/serverless-clusters.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
